#!/usr/bin/perl

use DBI;
use DBD::mysql;
use vars qw ( $db );

############
# DB Vars - You MUST change these to match a valid account on your database
print "DB USER? [snort] > ";
chomp (my $db_user = <STDIN>);
($db_user) || ($db_user = "snort");
print "DB PASSWORD? > ";
chomp (my $db_password = <STDIN>);
print "DB HOST? [localhost] > ";
chomp (my $db_host  = <STDIN>);
($db_host) || ($db_host = "localhost");
print "DB NAME? [snort] > ";
chomp (my $db_name    = <STDIN>);
($db_name) || ($db_name = "snort");

print << "EOF";

User: $db_user
Password: $db_password
Host: $db_host
Name: $db_name

Is this correct?[y/N] >
EOF

chomp($huh = <STDIN>);
if ($huh!~/y/i){
	die "OK, come back later when you're ready!\n";
}
&connect_to_db || &error("Invalid credentials, please try again.");

open (IN,"create_mysql_demarc") || &error("Cant find \"create_mysql_demarc\" file in current directory!");

my $sql_query;
while (<IN>){
	$sql_query .= $_ if ($_!~/^#/);
	if ($_=~/\;/){
		$sql_query=~s/\;//g;
		$db_ptr = &run_query($sql_query);
		$sql_query = ();
	}
}

print "X"x50 . "\n";
print " The database is now set up!\n";
print "X"x50 . "\n";
exit;

# Files for snort:
@rule_files = qw (
backdoor.rules
ddos.rules
dns.rules
dos.rules
exploit.rules
finger.rules
ftp.rules
icmp-info.rules
icmp.rules
info.rules
local.rules
misc.rules
netbios.rules
policy.rules
rpc.rules
rservices.rules
scan.rules
shellcode.rules
smtp.rules
sql.rules
telnet.rules
virus.rules
web-cgi.rules
web-coldfusion.rules
web-frontpage.rules
web-iis.rules
web-misc.rules
x11.rules
);

print "\n\nDo you want to load in the snort rules for SID 1? [Y/n]? > ";
chomp($huh = <STDIN>);
if ($huh=~/n/i){
	die "OK, come back later when you're ready!\n";
}

foreach (@rule_files){
	$file = $_;
	open (IN,$file) || die "Can't open $file : $!\n";
	$rules = ();
	while (<IN>){
		$rules .= $_;
	}
	close IN;
	&safe_slash(\$rules);
	$sql_query = "	INSERT INTO dm_rules \
			VALUES ( \
				'1','$file','$rules')";
	$db_ptr = &run_query($sql_query);

}

#now for snort.conf file:

open (IN,"snort.conf") || die "Can't open \"snort.conf\" : $!\n";
$found = 0;
$rules = ();
while (<IN>){
	$rules .= $_ if ($_!~/^include/i); #dont include those damn "include"s!
	if (!$found && $_=~/output database/){ #gets it near the correct position
		$rules .= "output database: log, mysql, user=$db_user password=$db_password dbname=$db_name host=$db_host\n\n";
		$found = 1;
	}
}
close IN;

&safe_slash(\$rules);
$sql_query = "INSERT INTO dm_conf VALUES ('1','','','$rules')";
$db_ptr = &run_query($sql_query);



print "X"x50 . "\n";
print " The database is now set up!\n";
print "X"x50 . "\n";



#############################################
# Functions
#############################################
sub run_query{
my ($sql_query) = @_;
&connect_to_db();
$q_count++;
print "Running Query $q_count\n";

my $prepared = $db->prepare($sql_query);
if (!$prepared){
        #Then there's an error with the syntax of the query:
        &error("Syntax Error in SQL Query:\n$sql_query\n:\n".$db->errstr);
}
my $dbquery = $prepared->execute();
if (my $error_string = $prepared->errstr){
        &error("$error_string : $sql_query");
}
return $prepared;
}
#####################
sub connect_to_db{
if (!$db || !$db->ping){

# function args override defaults, but error out if neither are there.
 $db_user         ||  &error("No database user specified.");
 $db_password     ||  &error("No database password specified.");
 $db_host         ||  &error("No database host specified.");
 $db_name         ||  &error("No database specified.");

 $db = DBI->connect("dbi:mysql:host=$db_host;database=$db_name", $db_user , $db_password) || &error("Connection Problem! ". $DBI::errstr);

}
return $db;
}
####################
sub error{
my ($le) = @_;
die "$le\n";
}
##################
sub safe_slash{
my ($string_ref) = @_;

$$string_ref=~s/(['\\])/\\$1/g;

}
